<?php
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Quake III server info for Fast info server (Fis)
Author: Sergey [iFX_RuBiTwa] Klokov
Mail: el_dest@mail.ru
Version: 1.0
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

function q3_server_info($server_response,$time_in,$time_out,$ip,$port,$display_info) {
	global $map,$players,$server_host_name,$server_ping,$full_info,$players_list,$fis_dir,$skin,$map_image,$server_address,$privileges;

	$server_ping 		= (int)(($time_out-$time_in)*1000);
	$server_info 		= explode("\n", $server_response);
	$server_response_data 	= explode("\\", $server_info[1]);
	$players_info 		= q3_players_info($server_info);
	$count_players 		= number_format(count($players_info))-1;
	$players_list 		= "";
	$promode			= "";
	$server_host_name 	= q3_name_color(q3_value_info("sv_hostname", $server_response_data));
	$g_gametype 		= q3_gametype(q3_value_info("g_gametype", $server_response_data));
	$map 				= q3_map_name(q3_value_info("mapname", $server_response_data));
	$allowdownload		= q3_value_info("sv_allowDownload", $server_response_data);
	$maxplayers 		= q3_value_info("sv_maxclients", $server_response_data);
	$fraglimit 			= q3_value_info("fraglimit", $server_response_data);
	$timelimit 			= q3_value_info("timelimit", $server_response_data);
	$gamename 			= q3_value_info("gamename", $server_response_data);
	$g_needpass 		= q3_value_info("g_needpass", $server_response_data);
	$sv_punkbuster 		= q3_value_info("sv_punkbuster", $server_response_data);
	$players 			= "$count_players / $maxplayers";
	if($g_needpass)$privileges  .= "Password ";
	if($sv_punkbuster)$privileges  .= "Punk buster";
	if($gamename="osp"){
		$gamename = q3_value_info("gameversion", $server_response_data);
		if(q3_value_info("server_promode", $server_response_data)=="1")$promode="(CPM)";
	}
	if (file_exists($fis_dir."images/q3/".$map.".jpg")){$map_image = "<img src='".$fis_dir."images/q3/".$map.".jpg'>";}else{$map_image = "<img src='".$fis_dir."images/q3/unknown.jpg'>";}
	include $skin."q3.php";
	$full_info 	= $q3_server_mon;
	if ($count_players != 0) {
		if ($display_info == "full"){
			$time = time();
			for ($i = 0; $i < $count_players;) {
				list ($frags_ping[$i], $name_player[$i]) = split ('\"', $players_info[$i]);
				list ($frags[$i], $ping[$i]) =  split(' ', $frags_ping[$i]);
				$name_player[$i] = htmlentities($name_player[$i]);
				$sql = dbquery("INSERT INTO ".DB_PREFIX."fast_info_server_tmp VALUES('".($i+1)."', 'q3', '$name_player[$i]', '$frags[$i]', '$ping[$i]', '$time')");
			$i++;
			}
			if (substr($gamename, 0, 3) == "OSP") {
				if ($g_gametype == "Single Player" || $g_gametype == "Tournament" || $g_gametype == "Free For All") {
					$array_active_players = explode(' ', q3_value_info("Players_Active", $server_response_data));
					$res = q3_detect_status_players(0,$array_active_players);
					$active_players = dbquery("SELECT * FROM ".DB_PREFIX."fast_info_server_tmp WHERE".$res."AND player_game_type='q3' AND tmp_time='$time'  ORDER BY player_frags DESC");
					if (dbrows($active_players) != 0){
						$players_list .= $q3_players_active_top;
						$player_place = 1;
						while ($data_active_players = dbarray($active_players)) {
							$player_name 	= q3_name_color($data_active_players['player_name']);
							$player_frags 	= $data_active_players['player_frags'];
							$player_ping 	= $data_active_players['player_ping'];
							include 		$skin."q3.php";
							$players_list 	.= $q3_players_active;
							$player_place++;
						}
						$players_list .= $q3_players_active_bottom;
					}
					$res = q3_detect_status_players(1,$array_active_players);
					$spect_players = dbquery("SELECT * FROM ".DB_PREFIX."fast_info_server_tmp WHERE tmp_time='$time' ".$res."AND player_game_type='q3' ORDER BY player_id DESC");
					if (dbrows($spect_players) != 0){
						$players_list .= $q3_spectators_top;
						while ($data_spect_players = dbarray($spect_players)) {
							$player_name 	= q3_name_color($data_spect_players['player_name']);
							$player_ping 	= $data_spect_players['player_ping'];
							include 		$skin."q3.php";
							$players_list 	.= $q3_spectators;
						}
						$players_list .= $q3_spectators_bottom;
					}
				} elseif ($g_gametype == "Team Death Match" || $g_gametype == "Capture The Flag" || $g_gametype == "Clan Arena") {
					$time_remaning = q3_value_info("Score_Time", $server_response_data);
					$blue_team = explode(' ', q3_value_info("Players_Blue", $server_response_data));
					$red_team = explode(' ', q3_value_info("Players_Red", $server_response_data));
					$blue_score = q3_value_info("Score_Blue", $server_response_data);
					$red_score = q3_value_info("Score_Red", $server_response_data);
					//Red team list
					$res = q3_detect_status_players(0,$red_team);
					$team_red = dbquery("SELECT * FROM ".DB_PREFIX."fast_info_server_tmp WHERE".$res."AND player_game_type='q3' AND tmp_time='$time'  ORDER BY player_frags DESC");
					include $skin."q3.php";
					$players_list .= $q3_red_team_top;
					if (dbrows($team_red) != 0){
						$player_place = 1;
						while ($data_team_red = dbarray($team_red)) {
							$player_name 	= q3_name_color($data_team_red['player_name']);
							$player_frags 	= $data_team_red['player_frags'];
							$player_ping 	= $data_team_red['player_ping'];
							include 		$skin."q3.php";
							$players_list 	.= $q3_red_team;
							$player_place++;
						}
					}
					$players_list .= $q3_red_team_bottom;

					//Blue team list
					$res = q3_detect_status_players(0,$blue_team);
					$team_blue = dbquery("SELECT * FROM ".DB_PREFIX."fast_info_server_tmp WHERE".$res."AND player_game_type='q3' AND tmp_time='$time'  ORDER BY player_frags DESC");
					include $skin."q3.php";
					$players_list .= $q3_blue_team_top;
					if (dbrows($team_blue) != 0){
						$player_place = 1;
						while ($data_team_blue = dbarray($team_blue)) {
							$player_name 	= q3_name_color($data_team_blue['player_name']);
							$player_frags 	= $data_team_blue['player_frags'];
							$player_ping 	= $data_team_blue['player_ping'];
							include 		$skin."q3.php";
							$players_list 	.= $q3_blue_team;
							$player_place++;
						}
					}
					$players_list .= $q3_blue_team_bottom;

					//Spectators list
					$res = q3_detect_status_players(1,$blue_team).q3_detect_status_players(1,$red_team);
					$spect_players = dbquery("SELECT * FROM ".DB_PREFIX."fast_info_server_tmp WHERE tmp_time='$time' ".$res."AND player_game_type='q3' ORDER BY player_id DESC");
					if (dbrows($spect_players) != 0){
						$players_list .= $q3_spectators_top;
						while ($data_spect_players = dbarray($spect_players)) {
							$player_name 	= q3_name_color($data_spect_players['player_name']);
							$player_ping 	= $data_spect_players['player_ping'];
							include 		$skin."q3.php";
							$players_list 	.= $q3_spectators;
						}
						$players_list .= $q3_spectators_bottom;
					}
				} else {
					$players = dbquery("SELECT * FROM ".DB_PREFIX."fast_info_server_tmp WHERE tmp_time='$time' AND player_game_type='q3' ORDER BY player_frags DESC");
					if (dbrows($players) != 0){
						$players_list .= $q3_players_active_top;
						$player_place = 1;
						while ($data_active_players = dbarray($players)) {
							$player_name 	= q3_name_color($data_active_players['player_name']);
							$player_frags 	= $data_active_players['player_frags'];
							$player_ping 	= $data_active_players['player_ping'];
							include 		$skin."q3.php";
							$players_list 	.= $q3_players_active;
							$player_place++;
						}
						$players_list .= $q3_players_active_bottom;
					}
				}
			} else {
				$players = dbquery("SELECT * FROM ".DB_PREFIX."fast_info_server_tmp WHERE tmp_time='$time' AND player_game_type='q3' ORDER BY player_frags DESC");
				if (dbrows($players) != 0){
					$players_list .= $q3_players_active_top;
					$player_place = 1;
					while ($data_active_players = dbarray($players)) {
						$player_name 	= q3_name_color($data_active_players['player_name']);
						$player_frags 	= $data_active_players['player_frags'];
						$player_ping 	= $data_active_players['player_ping'];
						include 		$skin."q3.php";
						$players_list 	.= $q3_players_active;
						$player_place++;
					}
					$players_list .= $q3_players_active_bottom;
				}
			}
		$sql = dbquery("DELETE FROM ".DB_PREFIX."fast_info_server_tmp WHERE tmp_time='$time' AND player_game_type='q3'");
		}
	} else {
		if ($display_info == "full"){
			$players_list .= $q3_no_players;
		}
	}
}

function q3_gametype($gametype) {
	if($gametype == "0"){
		$type = "Free For All";
	}elseif($gametype == "1"){
		$type = "Tournament";
	}elseif($gametype == "2"){
		$type = "Single Player";
	}elseif($gametype == "3"){
		$type = "Team Death Match";
	}elseif($gametype == "4"){
		$type = "Capture The Flag";
	}elseif($gametype == "5"){
		$type = "Clan Arena";
	}else{
		$type = "";
	}
	return $type;
}

function q3_detect_status_players($k,$array_active_players) {
	$res = "";
	if($k == 1){
		$i = 0;
		foreach ($array_active_players as $value) {
			$res .= "AND player_id!='$value' ";
			$i++;
		}
	}else{
		$i = 0;
		foreach ($array_active_players as $value) {
			if($i == 0){
				$res .= " (player_id='$value' ";
			}else{
				$res .= "OR player_id='$value' ";
			}
			$i++;
		}
		$res .= ")";
	}
	return $res;
}

function q3_value_info($server_response_value,$server_response_data) {
	$value = array_search($server_response_value, $server_response_data);
	if ($value) {
		$temp = $server_response_data[$value+1];
	} else {
		$temp = false;
	}
	return $temp;
}

function q3_players_info($server_info) {
	$po = 0;$pn = 0;
	foreach ($server_info as $value) {
		if ($po >= 2) {
			$players_info[$pn] = $value;
			$pn++;
		}
		$po++;
	}
	return $players_info;
}

function q3_map_name($name) {
$search = array("Q","W","E","R","T","Y","U","I","O","P","A",
			"S","D","F","G","H","J","K","L","Z","X",
			"C","V","B","N","M"
		);
$replace = array("q","w","e","r","t","y","u","i","o","p","a",
			"s","d","f","g","h","j","k","l","z","x",
			"c","v","b","n","m"
		);
	$name = str_replace($search, $replace, $name);
	return $name;
}

function q3_name_color($text) {
        $clr = array ( // colors
        "\"#000000\"", "\"#DA0120\"", "\"#00B906\"", "\"#E8FF19\"", //  1
        "\"#170BDB\"", "\"#23C2C6\"", "\"#E201DB\"", "\"#FFFFFF\"", //  2
        "\"#CA7C27\"", "\"#757575\"", "\"#EB9F53\"", "\"#106F59\"", //  3
        "\"#5A134F\"", "\"#035AFF\"", "\"#681EA7\"", "\"#5097C1\"", //  4
        "\"#BEDAC4\"", "\"#024D2C\"", "\"#7D081B\"", "\"#90243E\"", //  5
        "\"#743313\"", "\"#A7905E\"", "\"#555C26\"", "\"#AEAC97\"", //  6
        "\"#C0BF7F\"", "\"#000000\"", "\"#DA0120\"", "\"#00B906\"", //  7
        "\"#E8FF19\"", "\"#170BDB\"", "\"#23C2C6\"", "\"#E201DB\"", //  8
        "\"#FFFFFF\"", "\"#CA7C27\"", "\"#757575\"", "\"#CC8034\"", //  9
        "\"#DBDF70\"", "\"#BBBBBB\"", "\"#747228\"", "\"#993400\"", // 10
        "\"#670504\"", "\"#623307\""                                // 11
        );
            $search  = array (
            "/\^0/", "/\^1/", "/\^2/", "/\^3/",        //  1
            "/\^4/", "/\^5/", "/\^6/", "/\^7/",        //  2
            "/\^8/", "/\^9/", "/\^a/", "/\^b/",        //  3
            "/\^c/", "/\^d/", "/\^e/", "/\^f/",        //  4
            "/\^g/", "/\^h/", "/\^i/", "/\^j/",        //  5
            "/\^k/", "/\^l/", "/\^m/", "/\^n/",        //  6
            "/\^o/", "/\^p/", "/\^q/", "/\^r/",        //  7
            "/\^s/", "/\^t/", "/\^u/", "/\^v/",        //  8
            "/\^w/", "/\^x/", "/\^y/", "/\^z/",        //  9
            "/\^\//", "/\^\*/", "/\^\-/", "/\^\+/",    // 10
            "/\^\?/", "/\^\@/", "/\^</", "/\^>/",      // 11
            "/\^\&/", "/\^\)/", "/\^\(/", "/\^[A-Z]/", // 12
            "/\^\_/",                                  // 14
            "/&</", "/^(.*?)<\/font>/"                 // 15
            );

            $replace = array (
            "&<font color=$clr[0]>", "&<font color=$clr[1]>",   //  1
            "&<font color=$clr[2]>", "&<font color=$clr[3]>",   //  2
            "&<font color=$clr[4]>", "&<font color=$clr[5]>",   //  3
            "&<font color=$clr[6]>", "&<font color=$clr[7]>",   //  4
            "&<font color=$clr[8]>", "&<font color=$clr[9]>",   //  5
            "&<font color=$clr[10]>", "&<font color=$clr[11]>", //  6
            "&<font color=$clr[12]>", "&<font color=$clr[13]>", //  7
            "&<font color=$clr[14]>", "&<font color=$clr[15]>", //  8
            "&<font color=$clr[16]>", "&<font color=$clr[17]>", //  9
            "&<font color=$clr[18]>", "&<font color=$clr[19]>", // 10
            "&<font color=$clr[20]>", "&<font color=$clr[21]>", // 11
            "&<font color=$clr[22]>", "&<font color=$clr[23]>", // 12
            "&<font color=$clr[24]>", "&<font color=$clr[25]>", // 13
            "&<font color=$clr[26]>", "&<font color=$clr[27]>", // 14
            "&<font color=$clr[28]>", "&<font color=$clr[29]>", // 15
            "&<font color=$clr[30]>", "&<font color=$clr[31]>", // 16
            "&<font color=$clr[32]>", "&<font color=$clr[33]>", // 17
            "&<font color=$clr[34]>", "&<font color=$clr[35]>", // 18
            "&<font color=$clr[36]>", "&<font color=$clr[37]>", // 19
            "&<font color=$clr[38]>", "&<font color=$clr[39]>", // 20
            "&<font color=$clr[40]>", "&<font color=$clr[41]>", // 21
            "", "", "", "", "", "",                             // 22
            "", "</font><", "\$1"                               // 23
            );

            $ctext = preg_replace($search, $replace, $text);

            if ($ctext != $text)
            {
                $ctext = preg_replace("/$/", "</font>", $ctext);
            }
	return $ctext;
}
?>