<?php
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
CS 1.6 server info for Fast info server (Fis)
Author: Sergey [iFX_RuBiTwa] Klokov
Mail: el_dest@mail.ru
Version: 1.0
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

function cs_server_info($server_response,$time_in,$time_out,$ip,$port,$display_info) {
	global $map,$players,$server_host_name,$server_ping,$full_info,$players_list,$fis_dir,$skin,$map_image,$server_address,$privileges;

	$server_ping 		= (int)(($time_out-$time_in)*1000);
	$server_response 		= substr($server_response, 5);
	$server_address 		= get_value_string($server_response);
      $server_host_name 	= get_value_string($server_response);
      $map 				= get_value_string($server_response);
	$gamedir 			= get_value_string($server_response);
      $gamename 			= get_value_string($server_response);
      $count_players 		= get_value_byte($server_response);
	$maxplayers 		= get_value_byte($server_response);
	$netver 			= get_value_byte($server_response);
	$dedicated 			= get_value_byte($server_response);
	$os 				= get_value_byte($server_response);
	$pass 			= get_value_byte($server_response);
	$skip				= get_value_byte($server_response);
	$skip				= get_value_string($server_response);
	$skip				= get_value_string($server_response);
	$skip				= get_value_string($server_response);
	$skip				= get_value_lint($server_response);
	$skip				= get_value_lint($server_response);
	$skip				= get_value_byte($server_response);
	$skip				= get_value_byte($server_response);
	$secure 			= get_value_byte($server_response);
	$bots 			= get_value_byte($server_response);
	$players 			= "$count_players / $maxplayers";
	$privileges 		= "";
	if($bots)$privileges 	.= "Bots ";
	if($pass)$privileges    .= "Password ";
	if($secure)$privileges  .= "Secure";
	$players_list 		= "";
	if (file_exists($fis_dir."images/cs/".$map.".jpg")){$map_image = "<img src='".$fis_dir."images/cs/".$map.".jpg'>";}else{$map_image = "<img src='".$fis_dir."images/cs/unknown.jpg'>";}
	if ($display_info == "full"){
		include $skin."cs.php";
		$full_info 			= $cs_server_mon;
		$write_players 		= "\xFF\xFF\xFF\xFF\x55";
		$server 			= fsockopen("udp://".$ip,$port);
		socket_set_timeout($server, 3);
		fwrite ($server, $write_players);
		$players_response = fread($server, 2048);
		fclose($server);
		$players_response 	= substr($players_response, 6);
		$time = time();
		for ($i = 0; $i < $count_players;) {
			$skip 		= get_value_byte($players_response);
			$player_name 	= get_value_string($players_response);
			$player_frags 	= get_value_lint($players_response);
			$player_time 	= get_value_float($players_response);
			$minutes 		= floor($player_time / 60);
			$hours 		= floor($minutes / 60);
			$seconds 		= floor($player_time - ($minutes * 60));
			$minutes 		= $minutes - ($hours * 60);
			$player_time 	= sprintf("%02s:%02s:%02s", $hours, $minutes, $seconds);
			if($player_time == "00:00:00") $player_frags = "--";
			$sql = dbquery("INSERT INTO ".DB_PREFIX."fast_info_server_tmp VALUES('".($i+1)."', 'cs', '$player_name', '$player_frags', '$player_time', '$time')");
			$i++;
		}
		$players_db = dbquery("SELECT * FROM ".DB_PREFIX."fast_info_server_tmp WHERE tmp_time='$time' ORDER BY player_frags DESC");
		if (dbrows($players_db) != 0){
			$players_list 		.= $cs_players_top;
			$player_place 		= 1;
			while ($data_players_db = dbarray($players_db)) {
				$player_name 	= htmlentities($data_players_db['player_name']);
				$player_frags 	= $data_players_db['player_frags'];
				$player_time 	= $data_players_db['player_ping'];
				include 		$skin."cs.php";
				$players_list 	.= $cs_players;
				$player_place++;
			}
			$players_list 		.= $cs_players_bottom;
		}else{
			$players_list 		.= $cs_no_players;
		}
		$sql = dbquery("DELETE FROM ".DB_PREFIX."fast_info_server_tmp WHERE tmp_time='$time' AND player_game_type='cs'");
	}
}

function get_value_byte(&$data){
	$temp = $data[0];
	$data = substr($data, 1);
	return ord($temp);
}

function get_value_string(&$data){
	$temp = '';
	$i = 0;
	while (ord($data[$i]) != 0){
	    $temp .= $data[$i];
	    $i++;
	}
	$data = substr($data, $i+1);
	return $temp;
}

function get_value_sint(&$data){
	$temp = substr($data, 0, 2);
	$data = substr($data, 2);
	$array = @unpack('Sshort', $temp);
	return $array['short'];				
}

function get_value_lint(&$data){
	$temp = substr($data, 0, 4);
	$data = substr($data, 4);
	$array = @unpack('Lint', $temp);
	return $array['int'];
}

function get_value_float(&$data){
	$temp = substr($data, 0, 4);
	$data = substr($data, 4);
	$array = @unpack('ffloat', $temp);
	return $array['float'];
}
?>