<?php
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Main file for Fast info server (Fis)
Author: Sergey [iFX_RuBiTwa] Klokov
Mail: el_dest@mail.ru
Version: 1.0
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

function info_server($type,$ip,$port,$display_info=""){
	global $fis_dir,$server_address,$server_response,$server_status,$gameData;

	if ($type == "cs") {
		if($server = fsockopen("udp://".$ip,$port)) {
			$write = "\xFF\xFF\xFF\xFFTSource Engine Query\x00";
			socket_set_timeout($server,1);
			$time_in 		= microtime_float();
			fwrite($server, $write);
		  	$server_response 	= fread($server,4096);
           		$time_out 		= microtime_float();
			if ($server_response) {
		 		$server_status = "ON";
				include $fis_dir."includes/games_db/cs.php";
				cs_server_info($server_response,$time_in,$time_out,$ip,$port,$display_info);
			} else {
				if ($display_info == "full") redirect(FUSION_SELF);
				$server_status = "OFF";
			}
		} else {
			if ($display_info == "full") redirect(FUSION_SELF);
			$server_status = "OFF";
		}
	} elseif ($type == "q3") {
		if($server = fsockopen("udp://".$ip, $port)) {
			$write 		= "\xFF\xFF\xFF\xFFgetstatus\x00";
			socket_set_timeout($server,1);
			$time_in 		= microtime_float();
			fwrite($server, $write);
			$server_response 	= fread($server,2048);
           		$time_out 		= microtime_float();
			fclose($server);
			if ($server_response) {
				$server_address = $ip.":".$port;
		 		$server_status = "ON";
				include $fis_dir."includes/games_db/q3.php";
				q3_server_info($server_response,$time_in,$time_out,$ip,$port,$display_info);
			} else {
				if ($display_info == "full") redirect(FUSION_SELF);
				$server_status = "OFF";
			}
		} else {
			if ($display_info == "full") redirect(FUSION_SELF);
	  		$server_status = "OFF";
		}
	}
}

function microtime_float() {
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}
?>