<?php
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Srvers list for Fast info server (Fis)
Author: Sergey [iFX_RuBiTwa] Klokov
Mail: el_dest@mail.ru
Version: 1.0
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

require_once "maincore.php";
require_once "subheader.php";
require_once "side_left.php";

$fis_dir = INFUSIONS."fis/";

if (file_exists($fis_dir."lang/".$settings['locale'].".php")) {
	include $fis_dir."lang/".$settings['locale'].".php";
} else {
	include $fis_dir."lang/english.php";
}

include $fis_dir."includes/config.inc.php";
include $fis_dir."includes/main.inc.php";
include $skin."server_list.php";

if (!isset($server)) $server = "";
if ($server) {
	$sql = dbquery("SELECT * FROM ".$db_prefix."fast_info_server WHERE server_id='$server'");
	$rows = dbrows($sql);
	$data = dbarray($sql);
	$tables = $header;
	if ($rows != 0) {
		if($refresh != 0) echo "<meta http-equiv='refresh' content='$refresh'>";
		$ip = $data['server_ip'];
		$port = $data['server_port'];
		$type = $data['server_type'];
		info_server($type,$ip,$port,"full");
		opentable("<center>".$data['server_name']."</center>");
		echo $full_info.$players_list;
		closetable();
	} else {
		redirect(FUSION_SELF);
	}
} else {
	opentable("<center>".$locale['fis00']."</center>");
		$sql = dbquery("SELECT * FROM ".$db_prefix."fast_info_server ORDER BY server_order ASC");
		$rows = dbrows($sql);
		echo $header;
		$servers_list = "";
		if ($rows != 0) {
		if($refresh != 0) echo "<meta http-equiv='refresh' content='$refresh'>";
			while($data = dbarray($sql)) {
				$map 			= "--";
				$players 		= "--";
				$server_ping 	= "--";
				$server_status 	= "OFF";
				$server_db_name 	= "--";
				$server_address 	= "--";
				$server_host_name = "--";
				$image = $fis_dir."images/".$data['server_type'].".gif";
				$ip = $data['server_ip'];
				$port = $data['server_port'];
				$type = $data['server_type'];
				info_server($type,$ip,$port);
				if ($server_status == "ON") {$server_db_name = "<a href='".FUSION_SELF."?server=".$data['server_id']."' title='".$locale['fis08']."'>".$data['server_name']."</a>";}else{$server_db_name = $data['server_name'];}
				include($skin."server_list.php");
				$servers_list .= $servers;
			}
			echo $servers_list;
		} else {
			echo $no_servers;
		}
	echo $footer;
	echo "<br><br><center><span class='small2'>FIS  2006<br>By iFX_RuBiTwa</span></center>"; // Dont removed plz =)))
	closetable();
}
require_once "side_right.php";
require_once "footer.php";
?>
